///////////////////////// 1414 rountine Library ////////////////////////
// Autor: M.Korn 	Datum: 22.11.2016, 
// modifiziert ffreigeben von PB0 (hierfür wird PB4 verwendet)
////////////////////////////////////////////////////////////////////////
#include <avr/io.h>
#include <stdint.h>

#define  	LED_DDR		DDRB	// Adresseleitung, Richtungsregister.	
#define  	LED_PORT	PORTB	// Adresseleitung
#define  	LED_DDR_DATA DDRD	// Datenleitung, Richtungsregister
#define		LED_DATA	PORTD	// Datenleitung
#define  	LED_WR		PD7		// Schreib-Ausgang /WRITE
#define		Stelle		16		// eine 1414 Module = 4 Stelle, hier 2x Module = 8 Stelle
#define		AdrBreite	0x1E	// 0x1E = b00011110 = 4x Adresseleitung = 2hoch 4 = 16 Stelle


// Prototypen
void int1414 ();
void data1414 (char data);
void reset1414 ();
void set1414 (char data, char column);
void string1414(char string[]);



// initalisierte Werte
char string[];
int column1414 = 0;



// int1414 (); 				// beispielcode, zwingend fur korrekt Funktion, mit  Zuweisung von Port.
void int1414 (){
	LED_DDR = AdrBreite;		//Adresseleitung
	LED_DDR_DATA = 0xFF;		// Datenleitung
	int column1414=0;
	for(int i=0; i<Stelle; i++){
	LED_PORT = (column1414 & (AdrBreite & 0x0E))| ( (column1414<<4)& 0x10); // Adresse an Port setzen (3bit-Adresse, kaskadierbar durch Maske)
	LED_DATA &= ~ (1<<LED_WR); 	// Werte schreiben, /WRITE auf LOW setzen.
	LED_DATA = 0x20;           	// Leerzeichen an Port füttern
	LED_DATA |= (1<<LED_WR ); 	// schreiben beenden /WRITE auf HIGH setzen.
	column1414++; 				// Adressezähler
	}
	reset1414 ();
}



//	data1414 ( 0x30 & bcd[0]);   // beispiel-code, für Datensenden an 1414, inkrementale Stellenpostition.
	

void data1414 (char data ) {	// 1414 mit Daten speisen, inkremental
	LED_PORT = (column1414 & (AdrBreite & 0x0E))| ( (column1414<<4)& 0x10); // Adresse an Port setzen (3bit-Adresse, kaskadierbar durch Maske)
	LED_DATA &= ~(1<<LED_WR); 	// Werte schreiben, /WRITE auf LOW setzen.
	LED_DATA = (data & 0x7F);           	// Daten an Port füttern
	LED_DATA |= (1<<LED_WR ); 	// schreiben beenden /WRITE auf HIGH setzen.
	column1414--;				// Adressezähler
}


// reset1414 ();   // Beispielcode für zurücksetzen nach nutzung von Funktion "data1414"

void reset1414 () {
	column1414 = Stelle-1; 			// Adressezähler auf "NULL" setzen
}


 
//	set1414 (0x30 & bcd[1]); // beispielcode
 
void set1414 (char data, char column) { // gewünschte Stelle mit Daten füttern, nicht inkremental
	column1414 = column;			// Port mit gewünschte Adresse speisen.
	LED_PORT = (column1414 & (AdrBreite & 0x0E))| ( (column1414<<4)& 0x10); // Adresse an Port setzen (3bit-Adresse, kaskadierbar durch Maske)
	LED_DATA &= ~(1<<LED_WR);		// Werte schreiben, /WRITE auf LOW setzen.
	LED_DATA = (data & 0x7F);		// Daten an Port füttern
	LED_DATA |= (1<<LED_WR );		// schreiben beenden /WRITE auf HIGH setzen.
}



// string1414 ("hello") ;  // Beispielcode

void string1414(char string[]) {		// String  an 1414 schicken.
	for(int i=0; i<Stelle; i++) {		//for-Schleife
	data1414 (string[i]);				// Untenfunktion "data1414" mit Array-Daten füttern
	}									
	reset1414 ();							// Adressezähler zurücksetzen.
}

